// Version d'OpenGL
#version 330 core

const int  LargeurOrigine = 1024;
const int HauteurOrigine = 768;

uniform int LargeurDeFenetre;
uniform int HauteurDeFenetre;

in vec3 MonSommetEnEntree;
out vec4 MaCouleur;


// Fonction appellee pour chaque sommet
void main()
{
	int MaTransformation = 0;

	if (MaTransformation == 0) {

		// LES COORDONNEES TRANSMISES PAR LE PROGRAMME C++ NE SONT PAS MODIFIEES PAR LE SHADER

		gl_Position = vec4(MonSommetEnEntree, 1.0);

	} else if (MaTransformation == 1) {

		// LES COORDONNEES TRANSMISES PAR LE PROGRAMME C++ SONT MODIFIEES DE MANIERE A CE QUE LE CARRE APPARAISSE COMME UN CARRE
		// QUELLE QUE SOIT LA TAILLE DE LA FENETRE
		// LE CARRE GROSSI OU RETRECI EN MEME TEMPS QUE LA FENETRE

		float Aspect = float(LargeurDeFenetre) / HauteurDeFenetre;
		if (LargeurDeFenetre > HauteurDeFenetre) {
			gl_Position = vec4(MonSommetEnEntree.x/Aspect, MonSommetEnEntree.y, 0.0, 1.0);
		} else {
			gl_Position = vec4(MonSommetEnEntree.x, MonSommetEnEntree.y*Aspect, 0.0, 1.0);
		};
	} else {
		// LES COORDONNEES TRANSMISES PAR LE PROGRAMME C++ SONT MODIFIEES DE MANIERE A CE QUE LE CARRE APPARAISSE COMME UN CARRE
		// QUELLE QUE SOIT LA TAILLE DE LA FENETRE
		// LE CARRE A UNE TAILLE CONSTANTE QUELLE QUE SOIT LA TAILLE DE LA FENETRE
		// SI LA FENETRE EST TROP PETITE, LE CARRE "DEBORDE" DE LA FENETRE

		float TailleConstante;
		float Coefficient;

		if (LargeurOrigine > HauteurOrigine) {
			TailleConstante = float(HauteurOrigine)/2;
		} else {
			TailleConstante = float(LargeurOrigine)/2;
		}

                TailleConstante = 200;

		Coefficient = float(LargeurDeFenetre+TailleConstante)/LargeurDeFenetre - 1.;
		gl_Position.x = 2. * Coefficient * MonSommetEnEntree.x;
		Coefficient = float(HauteurDeFenetre+TailleConstante)/HauteurDeFenetre - 1.;
		gl_Position.y = 2. * Coefficient * MonSommetEnEntree.y;

		gl_Position.zw = vec2( 0.,1.);
	}

	// creation de la couleur du sommet
	// LE SOMMET (-0.5,-0.5) SERA NOIR
	// LE SOMMET (-0.5, 0.5) SERA VERT
	// LE SOMMET ( 0.5,-0.5) SERA ROUGE
	// LE SOMMET ( 0.5, 0.5) SERA JAUNE (ROUGE + VERT)
	MaCouleur = vec4(MonSommetEnEntree.x+0.5,MonSommetEnEntree.y+0.5, 0., 1.0);
}

// AUTRE EXEMPLE DE CALCUL DE LA COULEUR EN CHAQUE SOMMET
//	MaCouleur = vec4(MonSommetEnEntree.x+0.5,MonSommetEnEntree.y+0.5,0., 1.0);
